<?php

namespace TVn7\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerAwareTrait;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20180120155124 extends AbstractMigration implements ContainerAwareInterface
{

    use ContainerAwareTrait;

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() !== 'mysql', 'Migration can only be executed safely on \'mysql\'.');

        $this->addSql('ALTER TABLE tdb_membre ADD poste_by_default INT DEFAULT NULL');
        $this->addSql('ALTER TABLE tdb_membre ADD CONSTRAINT FK_1D82F92EE9B9534C FOREIGN KEY (poste_by_default) REFERENCES tdb_poste (id)');
        $this->addSql('CREATE INDEX IDX_1D82F92EE9B9534C ON tdb_membre (poste_by_default)');
    }

    public function postUp(Schema $schema)
    {
        $em = $this->container->get('doctrine')->getManager();

        $userRepo = $em->getRepository('TVn7UserBundle:Membre');
        $membres = $userRepo->findAll();

        foreach($membres as $membre) {
            $postes = $membre->getPostes();
             if (count($postes) > 0) {
                $postes_bureau = $postes->filter(function ($p) {
                    return $p->isBureau();
                });
                if (count($postes_bureau) == 0) {
                    $poste_by_default = $membre->getPostes()[0];
                } else {
                    $poste_by_default = $postes[0];
                }
                $membre->setPosteByDefault($poste_by_default);
                $this->write(sprintf("« %s » set by default for user %s", $poste_by_default, $membre));

            }
        }

        $this->write("Saving...");
        $em->flush();

    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() !== 'mysql', 'Migration can only be executed safely on \'mysql\'.');

        $this->addSql('ALTER TABLE tdb_membre DROP FOREIGN KEY FK_1D82F92EE9B9534C');
        $this->addSql('DROP INDEX IDX_1D82F92EE9B9534C ON tdb_membre');
        $this->addSql('ALTER TABLE tdb_membre DROP poste_by_default');
    }
}
